const { resolve } = require("./utils");
const pluginInit = require("./pluginInit");

/**
 * 在 plugins/index 中进行注入，如果不存，则创建并注入
 * @param {api} api
 * @param {string} importFrom: import xxx from '\<importFrom\>';
 * @param {string} defaultImport: import \<defaultImport\> from '\<importFrom\>';
 * @param {string[]} importList: import \<defaultImport\>, { ...\<importList\> } from '\<importFrom\>';
 */
module.exports = (api, importFrom, defaultImport, importList) => {
  pluginInit(api);

  api.transformScript(
    resolve("./src/plugins/index.ts"),
    require("./useInjectImport"),
    {
      from: importFrom,
      default: defaultImport,
      importList,
    }
  );
};
